! ESA (C) 2000-2018 
!
! This file is part of ESA's XMM-Newton Scientific Analysis System (SAS).
!
!    SAS is free software: you can redistribute it and/or modify
!    it under the terms of the GNU General Public License as published by
!    the Free Software Foundation, either version 3 of the License, or
!    (at your option) any later version.
!
!    SAS is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU General Public License for more details.
!
!    You should have received a copy of the GNU General Public License
!    along with SAS.  If not, see <http://www.gnu.org/licenses/>.
!--------------------------------------------------------------------
program checkoutput
!--------------------------------------------------------------------
! test if output image deviates by more than 1 % from reference image

use dal
use errorhandling

implicit none

real(kind=single) :: frac
integer(kind=int32) :: ix, iy
type(DataSetT)  :: set1, set2
type(ArrayT)    :: arr1, arr2

real(kind=single), dimension(:,:), pointer :: test, ref
integer ok

set1 = dataSet("expo_image.fits", read)
arr1 = array(set1, "PRIMARY",read)

set2 = dataSet("expo_refima.fits.gz", read)
arr2 = array(set2, "PRIMARY",read)

test => real32Array2Data(arr1)
ref  => real32Array2Data(arr2)

ok = 0

do ix=180,440,20
  do iy=180,440,20
    if (ref(ix,iy) > 0.0) then
      frac = test(ix,iy)/ref(ix,iy)
      if (frac < 0.80 .or. frac > 1.20) then
        print *,ix,iy,test(ix,iy),ref(ix,iy)
        ok = ok+1
      end if 
    end if
  end do
end do

call release(arr1)
call release(arr2)
call release(set1)
call release(set2)

if (ok > 20) call error("test failed","exposure image contains wrong values")

end program checkoutput

